#
# spec file for package muffin
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define soname  libmuffin
%define sover   0
%define typelib typelib-1_0-MetaMuffin-0_0
Name:           muffin
Version:        3.2.2
Release:        1.1
Summary:        Cinnamon Desktop default window manager
License:        GPL-2.0+ and MIT
Group:          System/GUI/Other
Url:            https://github.com/linuxmint/muffin
Source:         https://github.com/linuxmint/%{name}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
# PATCH-FIX-OPENSUSE muffin-svid-default-source.patch marguerite@opensuse.org -- Change _SVID_SOURCE to _DEFAULT_SOURCE.
Patch0:         %{name}-svid-default-source.patch
BuildRequires:  autoconf
BuildRequires:  autoconf-archive
BuildRequires:  automake
BuildRequires:  fdupes
BuildRequires:  gtk-doc
BuildRequires:  intltool
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  update-desktop-files
BuildRequires:  zenity
BuildRequires:  pkgconfig(cairo) >= 1.10.0
BuildRequires:  pkgconfig(cinnamon-desktop) >= 2.4.0
BuildRequires:  pkgconfig(clutter-1.0) >= 1.14.3
BuildRequires:  pkgconfig(cogl-1.0) >= 1.13.3
BuildRequires:  pkgconfig(gio-2.0) >= 2.25.10
BuildRequires:  pkgconfig(gl)
BuildRequires:  pkgconfig(gnome-doc-utils)
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  pkgconfig(gtk+-3.0) >= 3.10.0
BuildRequires:  pkgconfig(libcanberra-gtk3) >= 0.26
BuildRequires:  pkgconfig(libstartup-notification-1.0) >= 0.7
BuildRequires:  pkgconfig(pango) >= 1.14.0
BuildRequires:  pkgconfig(sm)
BuildRequires:  pkgconfig(xcomposite) >= 0.3
BuildRequires:  pkgconfig(xdamage)
BuildRequires:  pkgconfig(xfixes)
BuildRequires:  pkgconfig(xinerama)
BuildRequires:  pkgconfig(xrandr)
BuildRequires:  pkgconfig(xrender)
Requires:       cinnamon-gschemas
Requires:       zenity
Recommends:     %{name}-lang
Provides:       windowmanager
%glib2_gsettings_schema_requires

%description
Cinnamon Desktop default window manager.
Muffin uses GTK+ and Clutter to do everything.

%lang_package

%package -n %{soname}%{sover}
Summary:        Muffin shared libraries
Group:          System/Libraries

%description -n %{soname}%{sover}
Cinnamon Desktop default window manager.
Muffin uses GTK+ and Clutter to do everything.

This package provides Muffin's shared libraries.

%package -n %{typelib}
Summary:        Muffin Introspection bindings
Group:          System/Libraries

%description -n %{typelib}
Cinnamon Desktop default window manager.
Muffin uses GTK+ and Clutter to do everything.

This package provides the GObject Introspection bindings for muffin.

%package devel
Summary:        Muffin development files
Group:          Development/Libraries/Other
Requires:       %{soname}%{sover} = %{version}
Requires:       %{typelib} = %{version}

%description devel
Cinnamon Desktop default window manager.
Muffin uses GTK+ and Clutter to do everything.

This package provides the development files.

%prep
%setup -q
%patch0 -p1

%build
NOCONFIGURE=1 ./autogen.sh
%configure \
  --disable-static          \
  --disable-schemas-install \
  --enable-gtk-doc
make %{?_smp_mflags} V=1

%install
%make_install
%find_lang %{name}
%suse_update_desktop_file %{name}
find %{buildroot} -type f -name "*.la" -delete -print
%fdupes %{buildroot}

%post
%glib2_gsettings_schema_post

%postun
%glib2_gsettings_schema_postun

%post -n %{soname}%{sover} -p /sbin/ldconfig

%postun -n %{soname}%{sover} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS COPYING README README* rationales.txt debian/changelog
%{_bindir}/%{name}*
%{_libdir}/%{name}/
%exclude %{_libdir}/%{name}/Meta-Muffin.0.typelib
%exclude %{_libdir}/%{name}/Meta-Muffin.0.gir
%{_datadir}/%{name}/
%{_datadir}/applications/%{name}.desktop
%{_mandir}/man?/*.?%{?ext_man}
%{_datadir}/glib-2.0/schemas/*.gschema.xml

%files lang -f %{name}.lang
%defattr(-,root,root)

%files -n %{soname}%{sover}
%defattr(-,root,root)
%{_libdir}/%{soname}.so.%{sover}*

%files -n typelib-1_0-MetaMuffin-0_0
%defattr(-,root,root)
%{_libdir}/%{name}/Meta-Muffin.0.typelib

%files devel
%defattr(-,root,root)
%{_includedir}/%{name}/
%{_libdir}/%{soname}.so
%{_libdir}/pkgconfig/%{soname}.pc
%{_libdir}/pkgconfig/%{name}-plugins.pc
%{_libdir}/%{name}/Meta-Muffin.0.gir
%{_datadir}/gtk-doc/html/%{name}/

%changelog
* Sun Jan  8 2017 sor.alexei@meowr.ru
- Update to version 3.2.2:
  * Make background transitions configurable.
* Thu Nov 24 2016 sor.alexei@meowr.ru
- Update to version 3.2.1:
  * window groups: Don't assign IM popups to META_WINDOW_POPUP_MENU.
* Tue Nov  8 2016 sor.alexei@meowr.ru
- Update to version 3.2.0:
  * meta-window-actor: Fix unredirect heuristic Damage coordinates
    are relative to the drawable not to the screen. So we have to
    check whether x and y are 0 and not window_rect.x/y otherwise
    the herustic will never trigger for windows on monitors whos x
    and y are not 0.
  * meta-window-actor: Consider needs_destroy in is_destroyed().
    According to the documentation, the method returns "whether the
    X window that the actor was displaying has been destroyed" -
    that is very much true when we delay the actual actor
    destruction for a destroy animation, so update the method
    accordingly.
  * meta-window-actor: Do not request unredirection when destroyed
    WindowActors can outlive their corresponding window to animate
    unmap. Unredirecting the actor does not make sense in that
    case, so make sure to not request it.
  * window-actor: Skip frame-sync when the corresponding window
    is gone.
  * Migrate away from gnome-common deprecated vars and macros.
  * meta-window-actor: Change unredirection hints to match spec
    changes.
  * x11/window-props: Initialise the bypass compositor hint.
  * backgrounds: Add a simple crossfade effect on bg transitions,.
  * backgrounds: Clean up a couple things.
  * compositor: Clean up a bunch of deprecated clutter
    functionality.
  * wm-tester: Clean up gtk deprecations.
  * Remove old references to tooltips.
  * frames: Remove expose_delayed.
  * Don't remove client-side frame extents when maximizing
    (gh#linuxmint/Cinnamon#5343).
  * Add screen signal for skip_taskbar window hint changes.
    This is needed by the window list applet in Cinnamon to know
    when to remove (or add) an item in the window list.
  * cogl-utils.c: Don't skip error parameters.
  * meta-window-actor.c: Only override the unredirect heuristic
    with our unredirect-fullscreen-windows preference.
  * Make AX_ macros optional.
* Thu Jun 23 2016 sor.alexei@meowr.ru
- Update to version 3.0.5:
  * cogl-utils: Don't set such a tight restriction on texture sizes.
  * keybindings.c: Fix alignment calculation for handle_move_to -
    it was not accounting for GTK_FRAME_EXTENTS in the final x,y
    position.
  * window.c: Temporary workaround for gtk3 tooltip position bug
    and Gtk 3.18.
* Sun May 22 2016 sor.alexei@meowr.ru
- Update to version 3.0.4:
  * Use g_clear_pointer to clean up finalisation code.
  * window-actor: Remove custom region destruction methods with
    g_clear_pointer.
  * constraints.c: Ignore snapped windows whe maximising desktop
    windows.
  * window-actor: Fix leaked frame list.
* Thu May 12 2016 sor.alexei@meowr.ru
- Update to version 3.0.3 (changes since 3.0.1):
  * window.c: Handle META_TILE_MAXIMIZE in update_tile_mode, and
    move its call to handle both moving and resizing. This
    prevents strange resize behaviour when you move a window to an
    upper tile region without tiling it. Its tile state becomes
    inconsistent, and an attempt to resize it vertically ends up
    resizing in the wrong (or both) directions.
  * meta-window-actor.c: Put META_WINDOW_DND-type windows in the
    regular window group (xdndHandler.js in cinnamon expects it
    there).
* Sat May  7 2016 sor.alexei@meowr.ru
- Update to version 3.0.1:
  * display.c: Handle META_TILE_MAXIMIZE in
    meta_resize_gravity_from_tile_mode().
  * tiling: Fix resizing of partially maximised windows.
  * frames.c: Do not infinite loop on the variants GList.
    Make variable names less similar.
* Mon Apr 25 2016 sor.alexei@meowr.ru
- Update to version 3.0.0:
  * tiling: Wait to update window properties on tiled windows until
    after the window has been resized.
  * tiling: Remove the tiling property when a window is no longer
    tiled.
  * tiling: Remove a redundant check in the tiling keyboard handler.
  * window.c: Fix maximisation state when using tile hotkeys, clean
    up tile flags fully when the window is restored to normal.
  * tiling:  Fix mouse/keyboard resizing.
  * Enable tiling from a non-drag-initiated mouse move (for
    instance, via hotkey or titlebar menu).
  * keybindings.c: Get correct gravity during keyboard resize.
  * window.c: Don't animate the end of a tile resizing.
  * core: Assume we always have a compositor.
  * muffin.c: Fix executable from crashing when x11 isn't
    explicitly set as the clutter backend. We do this for Cinnamon
    itself in Cinnamon's main.c - it needs to be set before
    g_type_init.
  * theme.c: Get style context state instead of using
    GTK_STATE_FLAG_NORMAL, Gtk 3.20+ complains if the state passed
    doesn't match the context's current state. This quiets a lot of
    log spam when window focus changes.
  * window.c: Don't send configure notifies for OR windows this
    causes popup placement issues with Gtk 3.20+, the assertion is
    left out, as we still need to send configure notifies for OR
    windows in other cases.
  * prefs: Remove the live-hidden-windows preference.
    It's hardcoded to TRUE anyway.
  * Pull some upstream changes for mapping and unmapping windows.
  * compositor: Rework handling of our top_window_group.
  * Improve tracking of fullscreen windows.
  * Fix ppc64el packages build.
  * Removed unneeded postinst and prerm files.
- Rename and rebase muffin-2.4.0-SVID_SOURCE.patch to
  muffin-svid-default-source.patch.
* Wed Mar  9 2016 sor.alexei@meowr.ru
- Update to 2.8.5:
  * tiling: Account for gtk frame extents when evaluating whether a
    c-s-d window can be tiled or not.
  * prefs.c: Update keybindings even when the new keybinding is
    empty - this prevents old built-in (muffin) keybindings from
    continuing to work even after they've been cleared.
  * prefs: Don't attach modal dialogs by default.
  * cogl wrappers: Perform a sanity check on the width/height
    request and clamp the sizes to a maximum of (x) screen size.
  * display.c: prevent assertion errors when clicking out of
    window menus.
  * Disable frame sync when used when OpenGL version used by the
    driver is < 3.0.
  * meta-sync-ring.c: Simplify openGL version check to only check
    the major version number. Make the COGL_DRIVER_GL check a bit
    safer.
* Fri Nov 20 2015 sor.alexei@meowr.ru
- Update to 2.8.4:
  * meta-window-actor.c: Remove duplicate call to
    meta_window_get_input_rect().
- Require cinnamon-gschemas.
* Thu Nov 12 2015 sor.alexei@meowr.ru
- Update to 2.8.3:
  * Remove invalid (transfer) annnotations.
  * keybindings: make rebuilding keybindings an idle function.
    Prior to this, meta_display_rebuild_keybindings was called
    around 60 times at startup on my more-or-less stock desktop.
    Now it is called approximately once, as an idle function,
    after all keybinding changes are complete.
* Mon Nov  9 2015 sor.alexei@meowr.ru
- Update to 2.8.2:
  * Rework the strut handling code to better handle stacked monitor
    situations.
  * keybindings: Currently our move-to-center keybinding respects
    the current location of the mouse cursor when placing the
    window. Change the other move-window-to-* keybindings to match
    this behaviour. Also fixes issues with window being placed
    incorrectly with regards to the panel on multi-monitors with
    mixed panel layouts.
* Sat Oct 31 2015 sor.alexei@meowr.ru
- Update to 2.8.1:
  * constraints: clean up an unused variable.
  * Attach modal windows by default.
* Sun Oct 18 2015 sor.alexei@meowr.ru
- Update to 2.8.0:
  * screen.c: Fix toggle-desktop behaviour.
  * Fix some warnings.
  * compositor.c: Handle unstable API break.
  * Implement frame sync between apps and compositor.
  * Add meta-sync-ring and nvidia patch.
  * main.c: remove incorrect comment.
  * Keybindings: Change how the "Center window is screen" hotkey
    works so it centers the window on the proper screen in multiple
    monitor setups and matches the placement of centered, newly
    opened windows.
  * screen: Add a public meta_screen_get_current_monitor().
    A convenience function for getting the current monitor index
    for the cursor. Helpful when implementing features with proper
    multiple monitor support.
  * Center attached dialogs on the parent window instead of the
    parents titlebar.
  * Pull some upstream fixes from Mutter to allow getting/setting
    a windows icon geometry. This will allow us to get a proper
    working minimise effect when using multiple panel applets.
- Add missing zenity dependency.
- Spec cleanup.
* Tue Jun  2 2015 stefan@fam-elser.de
- update to version 2.6.1
* Thu Apr 23 2015 stefan@fam-elser.de
- update to version 2.4.5
* Mon Nov 10 2014 i@marguerite.su
- update version 2.4.1
  * re-add keybindings schema to allow cinnamon-desktop migration
    script to work
* Wed Nov  5 2014 i@marguerite.su
- update version 2.4.0
- add patch: muffin-2.4.0-SVID_SOURCE.patch
  * _BSD_SOURCE and _SVID_SOURCE are deprecated, use _DEFAULT_SOURCE
- drop openSUSE 12.3 support, it's going to EOL
* Mon Jul 14 2014 i@marguerite.su
- update version 2.3.0
  * Send destroy events for minimized, attached windows to Cinnamon,
    so the parent un-dimming can occur.
  * Fix #154
  * Don't break scrolling when 'special key to move windows' is disabled.
  * Ensure steam notifications appear over the panel.
- use a special tarball for openSUSE 12.3
  * muffin master adopt many GNOME 3.10+ changes for Hi-DPI support.
    while openSUSE 12.3 ships 3.8
- added patch: muffin-cogl-api.patch
  * fix api breaks in openSUSE 12.3
* Wed Jul  9 2014 stefan@fam-elser.de
- update version 2.2.6
* Thu May 22 2014 stefan@fam-elser.de
- update version 2.2.5
* Wed May 21 2014 stefan@fam-elser.de
- update version 2.2.4
* Mon May 19 2014 stefan@fam-elser.de
- update version 2.2.3
* Thu May  1 2014 i@marguerite.su
- update version 2.2.2
* Thu Apr 17 2014 i@marguerite.su
- update version 2.2.1
* Mon Nov 25 2013 johann.luce@wanadoo.fr
- update version 2.0.5
  * Real fix for double frame decorations when resizing corner-tiled windows
  * Revert "Temporary hack for resized corner-tiled window frame issues on themes"
  * Fix for desktop modal dialogs being centered on the workspace instead of the primary monitor.
  * Fix unescapable fullscreen in chrome/chromium.
  * Revert "Partial fix for errant tooltips - fixes all cases except nemo views"
  * Partial fix for errant tooltips - fixes all cases except nemo views
  * Temporary hack for resized corner-tiled window frame issues on themes
    that support tiling... this results in a gradually growing window if you
    resize repeatedly, but for now it prevents average users from getting the
    dreaded 'double frame'.  Still not sure what's causing.
  * Stop-gap fix for stuttered resizing of gtk3 windows.
  * Don't apply snapping rules to maximized windows when they're in a different workspace.
* Fri Nov  8 2013 johann.luce@wanadoo.fr
- update version 2.0.4
  * Improve frame styling for snapped/tiled windows in themes that support it
- 2.0.3
  * Only perform workspace switch on drag during a mouse drag. Fixes #2513
* Mon Oct 21 2013 i@marguerite.su
- update version 2.0.2
  * no upstream changelog available
- split typelib-1_0-MetaMuffin-0_0 subpackage.
  * remove previous workaround, upstream has another workaround
* Mon Nov  5 2012 nmo.marques@gmail.com
- Update to version 1.1.2
  + Fix crash when frameless window calls meta_window_move_frame
- Spec file rework
* Thu Sep 27 2012 nmo.marques@gmail.com
- Update to version 1.1.1
  + no upstream changelog available
  + bug fix point release
* Tue Sep 18 2012 nmo.marques@gmail.com
- Update to version 1.1.0
  + no upstream changelog available
- Remove muffin-1.0.9-fix_fsf_address.patch: fixed upstream
* Thu Sep  6 2012 nmo.marques@gmail.com
- Update to version 1.0.9
  + move from gconf to gsettings
  + add 'pkgconfig(sm)' to BRs; enable session management
  + spec updates & fixes
- Add muffin-1.0.9-fix_fsf_address.patch; taken from upstream, can
  be dropped next update.
* Mon May 14 2012 nmo.marques@gmail.com
- Update to version 1.0.3:
  + enable fixes to build with GNOME 3.4
* Tue Mar 13 2012 nmo.marques@gmail.com
- Update to version 1.0.2:
  + Minor fixes, cosmetical.
  + removed 'Provides'/'Obsoletes' for old typelib sub-package. It
    shouldnt be installed in updated installations.
  + Minor spec improvements.
* Fri Feb 17 2012 nmo.marques@gmail.com
- Update to version 1.0.1:
  + some cosmetic fixes
- Remove muffin-fix-fsf-address.patch; upstreamed
* Mon Feb 13 2012 nmarques@opensuse.org
- Merge internal typelib into main package and add self-obsoletion
  for smooth transiction.
- Filter 'typelib(Meta-3.0)' provides to avoid potential issues
  with 'mutter' typelib (same name). Report to upstream, should
  be fixed.
* Tue Feb  7 2012 nmarques@opensuse.org
- Add muffin-fix-fsf-address.patch: update FSF postal address in
  headers. Upstreamed.
* Mon Feb  6 2012 nmarques@opensuse.org
- TypeLib package has been corrected to follow namming conventions;
- Removed 'evil' typelib dependency from shared libs package.
- Added Obsoletes/Provides old typelib package for easy upgrade on
  existing customers.
* Sun Feb  5 2012 nmarques@opensuse.org
- Improved spec licensing texts.
* Sat Feb  4 2012 nmarques@opensuse.org
- Add spec license.
* Fri Jan 27 2012 cfarrell@suse.com
- License update: GPL-2.0+
  No indication of GPL-2.0 licenses in the package (i.e. "only")
* Thu Jan 26 2012 nmarques@opensuse.org
- Improve typelib package and some cosmetics
- Add typelib dependency to libmuffin
* Wed Jan 25 2012 nmarques@opensuse.org
- Split introspection bindings into: typelib-%%{_libname}
- Disable '-Werror' check through %%configure for openSUSE >= 1220,
  upstream needs to fix (need Factory build for debugging).
* Tue Jan 24 2012 nmarques@opensuse.org
- Initial package.
